From 48ba997d86f91a7de1b73c03f60ce1a6e64dbcef Mon Sep 17 00:00:00 2001
From: Alexandru Csete <oz9aec@gmail.com>
Date: Thu, 14 Mar 2019 20:56:31 +0100
Subject: [PATCH 09/13] Prevent zooming out too far

---
 src/qtgui/plotter.cpp | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

diff --git a/src/qtgui/plotter.cpp b/src/qtgui/plotter.cpp
index 37ec3c7..9bc6184 100644
--- a/src/qtgui/plotter.cpp
+++ b/src/qtgui/plotter.cpp
@@ -227,7 +227,7 @@ void CPlotter::mouseMoveEvent(QMouseEvent* event)
 
     QPoint pt = event->pos();
 
-    /* mouse enter / mouse leave events */
+    /* mouse ent er / mouse leave events */
     if (m_OverlayPixmap.rect().contains(pt))
     {
         //is in Overlay bitmap region
@@ -755,9 +755,7 @@ void CPlotter::mouseReleaseEvent(QMouseEvent * event)
 void CPlotter::zoomStepX(float step, int x)
 {
     // calculate new range shown on FFT
-    float new_range = qBound(10.0f,
-                             (float)(m_Span) * step,
-                             (float)(m_SampleFreq) * 10.0f);
+    float new_range = qBound(10.0f, m_Span * step, m_SampleFreq * 10.0f);
 
     // Frequency where event occured is kept fixed under mouse
     float ratio = (float)x / (float)m_OverlayPixmap.width();
@@ -765,6 +763,14 @@ void CPlotter::zoomStepX(float step, int x)
     float f_max = fixed_hz + (1.0 - ratio) * new_range;
     float f_min = f_max - new_range;
 
+    // ensure we don't go beyond the rangelimits
+    if (f_min < m_CenterFreq - m_SampleFreq / 2.f)
+        f_min = m_CenterFreq - m_SampleFreq / 2.f;
+
+    if (f_max > m_CenterFreq + m_SampleFreq / 2.f)
+        f_max = m_CenterFreq + m_SampleFreq / 2.f;
+    new_range = f_max - f_min;
+
     qint64 fc = (qint64)(f_min + (f_max - f_min) / 2.0);
 
     setFftCenterFreq(fc - m_CenterFreq);
-- 
2.20.1

